protected/models/User.php
<?php


	class User extends CActiveRecord
	{

		public $password_repeat;



		public static function model($className = __CLASS__)
		{
			return parent::model($className);
		}



		public function tableName()
		{
			return 'sy_user';
		}



		public function rules()
		{
			return array(
				array(
					'name, password, password_repeat',
					'required'
				),
				array(
					'password',
					'compare'
				),
				array(
					'password',
					'length',
					'min' => 6,
					'max' => 45
				),
				array(
					'name',
					'unique'
				),
				array(
					'name, password',
					'length',
					'max' => 45
				),
				array(
					'picture',
					'length',
					'max' => 100
				),
				array(
					'id, name, password, password_repeat, picture',
					'safe',
					'on' => 'search'
				),
				array(
					'password_repeat, picture',
					'safe'
				),
			);
		}



		public function relations()
		{
			return array(
				'relMessage' => array(
					self::HAS_MANY,
					'Message',
					'user'
				),
			);
		}



		public function attributeLabels()
		{
			return array(
				'id'              => 'ID',
				'name'            => 'Name',
				'password'        => 'Passwort',
				'password_repeat' => 'Passwort-Wiederholung',
				'lastLoginTime'   => 'Letzter Login',
				'picture'         => 'Profilbild',
			);
		}



		public function search()
		{
			$criteria = new CDbCriteria;
			$criteria->compare('id', $this->id);
			$criteria->compare('name', $this->name, true);
			$criteria->compare('password', $this->password, true);
			$criteria->compare('lastLoginTime', $this->lastLoginTime, true);
			$criteria->compare('picture', $this->picture, true);

			return new CActiveDataProvider($this, array(
				'criteria'   => $criteria,
				'pagination' => false,
			));
		}



		protected function afterValidate()
		{
			parent::afterValidate();
			$this->password = $this->encrypt($this->password);
		}



		public function encrypt($value)
		{
			return md5($value);
		}



		public static function setLastLoginTime($idUser)
		{
			$model = UserController::loadModel($idUser);
			$date = new \DateTime();
			$model->lastLoginTime = $date->format('Y-m-d H:i:s');
			$model->save();
		}



		//
		//  Returns path to profile picture
		//
		public static function loadPictureUrl($filename)
		{
			if ($filename != "") {
				return '/pictures/' . $filename;
			}

			return 'http://placekitten.com/g/300/300';
		}


		//
		//  Counts total count of words of user
		//
		public static function getWordCount($idUser)
		{
			$totalWordCount = 0;
			$critMessage = new CDbCriteria();
			$critMessage->addCondition("fromuser = '$idUser'");
			$mMessages = Message::model()->findAll($critMessage);
			foreach ($mMessages as $message) {
				$totalWordCount += Message::getWordCount($message->text);
			}

			return $totalWordCount . " Wörter";
		}



		//
		//  Returns user name for cases where relation-based lazy-loading may fail
		//
		public static function getUsername($idUser)
		{
			$name = 'Unbekannt';
			$mUser = User::model()->findByPk($idUser);
			if (!empty($mUser)) {
				$name = $mUser->name;
			}

			return $name;
		}



		/*
		 * Returns when to expect answer statistically based on the avg. time from msgs. to the user and his response added onto the last login time or last msg., whichever was last
		 */
		public static function getEstimatedAnswerTime($idUser)
		{
			$responseTimeKumulated = 0;
			//Fetch all messages ever sent to user
			$critMessageToUser = new CDbCriteria();
			$critMessageToUser->addCondition("touser = '$idUser'");
			$critMessageToUser->order = 'date DESC';
			//$critMessage->group = 'idFromUser';
			$mMessagesToUser = Message::model()->findAll($critMessageToUser);
			$numberOfMsg = count($mMessagesToUser);
			//iterate through every message to find answer and add the response time to the kumulated one
			foreach ($mMessagesToUser as $msg) {
				$idMsg = $msg->id;
				$idFromUserMsg = $msg->idFromUser;
				$datetimeMsg = strtotime($msg->date);
				//get next answer from $idUser and calculate the time delta from toMsg to aw.
				$critAnswer = new CDbCriteria;
				$critAnswer->addCondition("idFromUser = '$idUser'");
				$critAnswer->addCondition("idToUser = '$idFromUserMsg'");
				$critAnswer->addCondition("id > '$idMsg'");
				$critAnswer->order = 'id ASC';
				$mAnswer = Message::model()->find($critAnswer);
				$datetimeAnswer = strotime($mAnswer->date);
				$responseTimeKumulated += $datetimeAnswer - $datetimeMsg;
			}
			//if user has receives messages:
			if ($numberOfMsg != 0) {
				//use static kumulated count of the time delta and the count of msgs to get the avg. response time
				$responseTimeAvg = $responseTimeKumulated / $numberOfMsg;
				//add this avg. to the last login time or last sent message, whichever was last
				$lastLoginTime = null;
				$lastMsgSent = mull;
				$mUser = User::model()->findByPk($idUser);
				//user has logged in
				if (!empty($mUser)) {
					$lastLoginTime = $mUser->lastLoginTime;
				}
				$critLastMsgSent = new CDbCriteria;
				$critLastMsgSent->addCondition("fromUser = '$idUser'");
				$critLastMsgSent->order = 'date DESC';
				$mLastMsgSent = Message::model()->find($critLastMsgSent);
				//user has sent an message
				if (!empty($mLastMsgSent)) {
					$lastMsgSent = $mLastMsgSent->date;
				}
				//last action plus the avg response time is the expected answer time if user receives a msg this very moment
				if ($lastLoginTime != null || $lastMsgSent != null) {
					//find last action (log-in or sent msg)
					$responseDatetimeExpected = null;
					$lastAction = null;
					if ($lastMsgSent > $lastLoginTime) {
						$lastAction = $lastMsgSent;
					} else {
						$lastAction = $lastLoginTime;
					}
					//calculation of expected answering datetime
					$responseDatetimeExpected = date('H:i d.m', strtotime($lastAction + $responseTimeAvg));

					return $responseDatetimeExpected;
				}
			}

			return 0;
		}

	}

protected/controllers/UserController.php
<?php

	class UserController extends Controller
	{

		public $layout = '//layouts/mainContent';



		public function filters()
		{
			return array(
				'accessControl',
				// perform access control for CRUD operations
				'postOnly + delete',
				// we only allow deletion via POST request
			);
		}



		public function accessRules()
		{
			return array(
				array(
					'allow',
					// allow authenticated user to perform 'view', 'update' and 'delete' actions
					'actions' => array(
						'view',
						'update',
					),
					'users'   => array('@'),
				),
				array(
					'allow',
					// allow admin user to perform 'admin' action
					'actions' => array(
						'admin',
						'create',
						'delete',
					),
					'users'   => array('philipp'),
				),
				array(
					'deny',
					// deny all users
					'users' => array('*'),
				),
			);
		}




		//
		//  Views current user
		//
		public function actionView()
		{
			$id = Yii::app()->user->id;
			$this->render('view', array(
				'model' => $this->loadModel($id),
			));
		}



		//
		// Creates a new user
		//
		public function actionCreate()
		{
			$model = new User;
			if (isset($_POST['User'])) {
				$model->attributes = $_POST['User'];
				if (!empty($_FILES['User']['tmp_name']['picture'])) {
					$rnd = rand(0, 999999); // generate random number between 0-9999
					$file = CUploadedFile::getInstance($model, 'picture');
					$fileName = substr("{$rnd}-{$file}", -100);
					$model->picture = $fileName;
					if ($model->save()) {
						$file->saveAs('pictures/' . $fileName);
						$this->redirect(array('user/view'));
					}
				} else {
					$model->picture = "";
					if ($model->save()) {
						$this->redirect(array('user/view'));
					}
				}
			}
			$this->render('create', array(
				'model' => $model,
			));
		}




		//
		//  Updates current user
		//
		public function actionUpdate()
		{
			$model = $this->loadModel(Yii::app()->user->id);
			// Uncomment the following line if AJAX validation is needed
			// $this->performAjaxValidation($model);
			if (isset($_POST['User'])) {
				$model->attributes = $_POST['User'];
				if (!empty($_FILES['User']['tmp_name']['picture'])) {
					//TODO: DELETE OLD PICTURE
					$rnd = rand(0, 999999); // generate random number between 0-9999
					$file = CUploadedFile::getInstance($model, 'picture');
					$fileName = substr("{$rnd}-{$file}", -100);
					$model->picture = $fileName;
					if ($model->save()) {
						$file->saveAs('pictures/' . $fileName);
						$this->redirect(array('user/view'));
					}
				} else {
					//TODO: DELETE OLD PICTURE
					$model->picture = "";
					if ($model->save()) {
						$this->redirect(array('user/view'));
					}
				}
			}
			$this->render('update', array(
				'model' => $model,
			));
		}



		//
		//  Delete current user and all messages send by him
		//
		public function actionDelete()
		{
			$idUser = Yii::app()->user->id;
			if ($this->loadModel($idUser)->delete()) {
				Yii::app()->user - setFlash('Erfolg', 'Dein Nutzeraccount wurde erfolgreich gelöscht');
				$critMessage = new CDbCriteria();
				$critMessage->addCondition("fromuser = '$idUser'");
				$mMessages = Message::model()->findAll($critMessage);
				foreach ($mMessages as $message) {
					$message->delete();
				}
				$critReadstatus = new CDbCriteria();
				$critReadstatus->addCondition("user = '$idUser'");
				$mReadstatus = Readstatus::model()->findAll($critReadstatus);
				foreach ($mReadstatus as $readstatus) {
					$readstatus->delete();
				}
				//TODO: DELETE PICTURE TOO
			} else {
				Yii::app()->user - setFlash('Fehler', 'Dein Nutzeraccount wurde nicht gelöscht');
			}
			$this->redirectarray('site/login');
		}



		public function actionAdmin()
		{
			$model = new User('search');
			$model->unsetAttributes(); // clear any default values
			if (isset($_GET['User'])) {
				$model->attributes = $_GET['User'];
			}

			$this->render('admin', array(
				'model' => $model,
			));
		}



		public function loadModel($id)
		{
			$model = User::model()->findByPk($id);
			if ($model === null) {
				throw new CHttpException(404, 'The requested page does not exist.');
			}

			return $model;
		}



		protected function performAjaxValidation($model)
		{
			if (isset($_POST['ajax']) && $_POST['ajax'] === 'user-form') {
				echo CActiveForm::validate($model);
				Yii::app()->end();
			}
		}

	}

protected/views/user/_search.php
<div class="col-lg-10 col-lg-offset-1">
	<?php
		$form = $this->beginWidget('bootstrap.widgets.TbActiveForm', array(
			'action' => Yii::app()->createUrl($this->route),
			'method' => 'get',
		));
	?>

	<div class="row">
		<?= $form->textFieldControlGroup($model, 'id'); ?>
	</div>

	<div class="row">
		<?=
			$form->textFieldControlGroup($model, 'name', array(
				'size'      => 45,
				'maxlength' => 45
			)); ?>
	</div>

	<div class="row">
		<?=
			$form->passwordFieldControlGroup($model, 'password', array(
				'size'      => 45,
				'maxlength' => 45
			)); ?>
	</div>

	<div class="row">
		<?= $form->textFieldControlGroup($model, 'lastLoginTime'); ?>
	</div>

	<div class="row">
		<?= $form->textFieldControlGroup($model, 'picture'); ?>
	</div>

	<div class="row buttons">
		<?=
			TbHtml::submitButton("Suchen", array(
				'class' => 'btn btn-sm btn-info col-lg-12 col-xs-12',
			)) ?>
	</div>

	<?php $this->endWidget(); ?>
</div><!-- search-form -->
<div class="clearfix"></div>

protected/views/user/admin.php
<?php
	//Tabuntertitel
	$this->pageTitle = "Nutzerverwaltung";
	Yii::app()->clientScript->registerScript('search', "
$('.search-button').click(function(){
	$('.search-form').toggle();
	return false;
});
$('.search-form form').submit(function(){
	$('#user-grid').yiiGridView('update', {
		data: $(this).serialize()
	});
	return false;
});
");
?>

<div class="well text-center">
	<h3> Account-Administration </h3>

	<p>
		<small>
			<i> Optional lässt sich mit Vergleichsoperatoren arbeiten (<b>&lt;</b>, <b>&lt;=</b>, <b>&gt;</b>, <b>&gt;=</b>, <b>&lt;&gt;</b>
				oder <b>=</b>), welche dem Suchparameter vorangestellt sein müssen: </i>
			<?php echo CHtml::link('Erweiterte Suche', '#', array('class' => 'search-button')); ?>
		</small>
	</p>

	<div class="search-form text-center" style="display:none">
		<?php
			$this->renderPartial('_search', array(
				'model' => $model,
			));
		?>
	</div>

	<div class="text-left">
		<?php
			$this->widget('bootstrap.widgets.TbGridView', array(
				'type'         => 'striped',
				'summaryText'  => '',
				'id'           => 'user-grid',
				'dataProvider' => $model->search(),
				'filter'       => $model,
				'columns'      => array(
					'id',
					'name',
					'password',
					array(
						'name'  => 'lastLoginTime',
						'value' => 'date("d.m.Y H:i", strtotime($data->lastLoginTime))',
					),
					'picture',
				),
			));
		?>
	</div>



	<p>
		<?=
			TbHtml::linkButton('Account anlegen', array(
				'class' => 'btn btn-sm btn-info col-lg-12 col-xs-12',
				'url'   => Yii::app()->createUrl('user/create'),
			)) ?>
	</p>
</div>

protected/views/user/create.php
<?php
	//Tabuntertitel
	$this->pageTitle = "Profil";
?>
<?php //Benachrichtigungen
	$this->widget('ext.toastr.HzlToastr', array(
		'flashMessagesOnly' => true,
		'options'           => array(
			'timeOut' => 8000,
		)
	));
?>

<div class="row">
	<br><br>

	<div class="col-lg-4 col-lg-offset-3 text-center">
		<div class="well wobble-horizontal">
			<div>
				<h3>Profil anlegen</h3>
				<br>
			</div>
			<?php
				$form = $this->beginWidget('bootstrap.widgets.TbActiveForm', array(
					'layout'               => TbHtml::FORM_LAYOUT_INLINE,
					'id'                   => 'user-form',
					'enableAjaxValidation' => false,
					'htmlOptions'          => array(
						'enctype' => 'multipart/form-data'
					)
				));
			?>

			<?=
				$form->textFieldControlGroup($model, 'name', array(
					'size'        => 45,
					'maxlength'   => 45,
					'placeholder' => 'Benutzername',
					'span'        => 12,
				)); ?> <br> <br>

			<?=
				$form->passwordFieldControlGroup($model, 'password', array(
					'size'        => 45,
					'maxlength'   => 45,
					'placeholder' => 'Passwort',
				)); ?> <br> <br>

			<?=
				$form->passwordFieldControlGroup($model, 'password_repeat', array(
					'size'        => 45,
					'maxlength'   => 45,
					'placeholder' => 'Passwort wiederholen',
				)); ?> <br> <br>

			<?= $form->fileFieldControlGroup($model, 'picture'); ?> <br> <br>

			<?=
				TbHtml::submitButton("Erstellen", array(
					'class' => 'btn btn-sm btn-info col-lg-12',
				)); ?>

			<?php $this->endWidget(); ?>
		</div>
	</div>
</div>

protected/views/user/update.php
<?php
	//Tabuntertitel
	$this->pageTitle = "Mein Profil aktualisieren";
?>
<?php //Benachrichtigungen
	$this->widget('ext.toastr.HzlToastr', array(
		'flashMessagesOnly' => true,
		'options'           => array(
			'timeOut' => 8000,
		)
	));
?>

<div class="row">
	<br><br>

	<div class="col-lg-4 col-lg-offset-4 text-center">
		<div class="well wobble-horizontal">
			<div>
				<h3>Profil aktualisieren</h3>
				<br>
			</div>
			<?php
				$form = $this->beginWidget('bootstrap.widgets.TbActiveForm', array(
					'layout'               => TbHtml::FORM_LAYOUT_INLINE,
					'id'                   => 'user-form',
					'enableAjaxValidation' => false,
					'htmlOptions'          => array(
						'enctype' => 'multipart/form-data'
					)
				));
			?>

			<?=
				$form->textFieldControlGroup($model, 'name', array(
					'size'        => 45,
					'maxlength'   => 45,
					'placeholder' => 'Benutzername',
					'span'        => 12,
				)); ?> <br> <br>

			<?=
				$form->passwordFieldControlGroup($model, 'password', array(
					'size'        => 45,
					'maxlength'   => 45,
					'placeholder' => 'Passwort',
				)); ?> <br> <br>

			<?=
				$form->passwordFieldControlGroup($model, 'password_repeat', array(
					'size'        => 45,
					'maxlength'   => 45,
					'placeholder' => 'Passwort wiederholen',
				)); ?> <br> <br>

			<?= $form->fileFieldControlGroup($model, 'picture'); ?> <br> <br>

			<?=
				TbHtml::submitButton("Aktualisieren", array(
					'class' => 'btn btn-sm btn-info col-lg-12 col-xs-12 round-corners',
				)); ?>

			<?php $this->endWidget(); ?>
		</div>
	</div>
</div>

protected/views/user/view.php
<?php
	$this->pageTitle = "Mein Profil";
?>

<div class="col col-lg-4 col-lg-offset-4 text-center col-xs-12">
<div class="well wobble-horizontal">
		<h3>
			<?= $model->name; ?> <br>
		</h3>
		<br>
		<img src="<?= User::loadPictureUrl($model->picture) ?>" class="img-responsive img-rounded center-block" alt="Profilbild"></a>
		<br>
		<?php
			$this->widget('bootstrap.widgets.TbDetailView', array(
				'data'       => $model,
				'attributes' => array(
					array(
						'name'  => 'lastLoginTime',
						'value' => Allgemein::doDateFormat($model->lastLoginTime) . ' um ' . Allgemein::doTimeFormat($model->lastLoginTime),
					),
					array(
						'name'  => 'Geschrieben',
						'value' => User::getWordCount($model->id),
					)
				),
			));
		?>
		<?=
			TbHtml::linkButton("Profil aktualisieren", array(
				'class' => 'btn btn-sm btn-info col-lg-12 col-xs-12 round-corners',
				'url'   => array('user/update'),
			))?> <br> <br>
		<?=
			TbHtml::linkButton("Profil löschen", array(
				'class' => 'btn btn-sm btn-danger col-lg-12 col-xs-12 round-corners',
				'url'   => array('user/delete'),
			))?>
		<br>
	</div>
</div>